/*
 AUTOR: MICROSIDE TECHNOLOGY S.A. DE C.V.
 FECHA: NOVIEMBRE DE 2020
*/

/*
---------------------------------------------------------------------------
En esta prctica se implementa una comunicacin USB configurada como CDC 
(Comunications Devices Class) emulando un puerto serial UART para lectura 
de la luminosidad con el X-NODE Ambient Light (XB009), as como la medicin 
de temperatura y humedad con el X-NODE Temp & Hum (XB003). Los datos sern 
solicitados a travs de comandos y podrn ser visualizados mediante una GUI 
(Graphical User Interface) que se ejecuta mediante el software LabVIEW.
---------------------------------------------------------------------------
*/ 

#include <18F4550.h>                            //Incluye el microcontrolador con el que se va a trabajar 
#use delay(clock=48Mhz, crystal)                //Tipo de oscilador y frecuencia dependiendo del microcontrolador 
#use rs232(baud=115200, xmit=PIN_C6, rcv=PIN_C7, stream=UART)   //Comunicaci?n serial a 115200bps, 1 bit de paro, sin paridad
#zero_ram
#build(reset=0x02000,interrupt=0x02008)         //Asignacin de los vectores de reset e interrupcin
#org 0x0000,0x1FFF {}                           //Reserva espacio en la memoria para la versin con bootloader

//--------------------------------------------------------------------------------------------------------------------

#include <usb_cdc.h>      //LIBRERIA USB
#include <usb_desc_cdc.h> //LIBRERIA USB

char c,u;                 //Crea variables tipo char para guardar los datos

void main() {

usb_cdc_init();           // Configuramos al puerto virtual
usb_init();               //inicializamos el USB

      while (!usb_cdc_connected()) {} // espera a detectar una transmision de la PC
      while (true)
      {
         usb_task();
         if(usb_enumerated())         // Espera a que el dispositivo sea enumerado
         {
            if (usb_cdc_kbhit())
            {
               c = usb_cdc_getc();    //Espera a recibir un datos por el puerto USB
               putc(c,UART);          //Enva la informacion por UART
            }

            if (kbhit(UART))
            {
               u=getc(UART);          //Recibe informacion por UART
               usb_cdc_putc(u);       //Envia informacion hacia la computadora por puerto emulado USB
            }
         }
      }
   }

